GzipCompressorOutputStream
Date: 2017-02-08

org.apache.commons.compress.compressors.gzip

## Class GzipCompressorOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.apache.commons.compress.compressors.CompressorOutputStream
    - - org.apache.commons.compress.compressors.gzip.GzipCompressorOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public class GzipCompressorOutputStream
      extends CompressorOutputStream

  Compressed output stream using the gzip format. This implementation improves over the standard `GZIPOutputStream` class by allowing the configuration of the compression level and the header metadata (filename, comment, modification time, operating system and extra flags).
  See Also:
    GZIP File Format Specification

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GzipCompressorOutputStream(java.io.OutputStream out)` Creates a gzip compressed output stream with the default parameters.
    `GzipCompressorOutputStream(java.io.OutputStream out, GzipParameters parameters)` Creates a gzip compressed output stream with the specified parameters.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `void` | `finish()` Finishes writing compressed data to the underlying stream without closing it.
    `void` | `flush()`
    `void` | `write(byte[] buffer)`
    `void` | `write(byte[] buffer, int offset, int length)`
    `void` | `write(int b)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GzipCompressorOutputStream

          public GzipCompressorOutputStream(java.io.OutputStream out)
                                     throws java.io.IOException

      Creates a gzip compressed output stream with the default parameters.
      Parameters:
        `out` - the stream to compress to
      Throws:
        `java.io.IOException` - if writing fails

    - #### GzipCompressorOutputStream

          public GzipCompressorOutputStream(java.io.OutputStream out,
                                    GzipParameters parameters)
                                     throws java.io.IOException

      Creates a gzip compressed output stream with the specified parameters.
      Parameters:
        `out` - the stream to compress to
        `parameters` - the parameters to use
      Throws:
        `java.io.IOException` - if writing fails
      Since:
        1.7

  - ### Method Detail

    - #### write

          public void write(int b)
                     throws java.io.IOException

      Specified by:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write(byte[] buffer)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`
      Since:
        1.1

    - #### write

          public void write(byte[] buffer,
                   int offset,
                   int length)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`
      Since:
        1.1

    - #### finish

          public void finish()
                      throws java.io.IOException

      Finishes writing compressed data to the underlying stream without closing it.
      Throws:
        `java.io.IOException` - on error
      Since:
        1.7

    - #### flush

          public void flush()
                     throws java.io.IOException

      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`
      Since:
        1.7

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`